﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


using System.Windows.Forms;

using System.Xml;
using System.IO;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;
using System.Xml.Serialization;

using System.ServiceModel;

namespace getReportsC
{
    class WCF_call
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        /// 
        /// 

        // [STAThread]

        public static StringBuilder builder;


        private static string MessageXMLIn = string.Empty;
        private static string MessageXMLOut = string.Empty;


        public static String response = "";




        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }
        public static void runWebServ()
        {
            Serv.ReportRoute rr = new Serv.ReportRoute { Stops = new Serv.StopLocation[3] };
            List<Serv.ReportRoute> listr = new List<Serv.ReportRoute>();

            
            rr.Stops[0] = new Serv.StopLocation
            {
                Address = new Serv.Address
                {
                    City = "Princeton",
                    State = "NJ",
                    Zip = "08540"
                },
                Label = "Princeton",
                Region = Serv.DataRegion.NA,
                RegionSpecified = true
            };
            rr.Stops[1] = new Serv.StopLocation
            {
                Address = new Serv.Address
                {
                    City = "Bensalem",
                    State = "PA",
                    Zip = "19020"
                },
                Label = "Bensalem",
                Region = Serv.DataRegion.NA,
                RegionSpecified = true
            };


            rr.Stops[2] = new Serv.StopLocation
            {
                Address = new Serv.Address
                {
                    City = "Philadelphia",
                    State = "PA",
                    Zip = "19123"
                },
                Label = "Philly",
                Region = Serv.DataRegion.NA,
                RegionSpecified = true
            };




            rr.ReportTypes = new Serv.ReportType[2];
            rr.ReportTypes[0] = new Serv.StateReportType();
            rr.ReportTypes[1] = new Serv.MileageReportType();




            rr.Options = new Serv.RouteOptions
            {
                HighwayOnly = true,
                HubRouting = false,
                HighwayOnlySpecified = true,
                DistanceUnits = Serv.DistanceUnits.Miles,
                VehicleType = Serv.VehicleType.Truck,
                VehicleTypeSpecified = true
            };

            rr.ReportingOptions = new Serv.ReportOptions
            {
                UseTollData = false,
                UseTollDataSpecified = false
            };


            listr.Add(rr);


            string apiKey = Form1.apiKeyVal;
            
            string dataVer = Form1.dataVersion;


            Serv.ReportRequest servReq = new Serv.ReportRequest
            {
                Header = new Serv.RequestHeader
                {
                    RequestType = "GetReports",
                    DataVersion = dataVer
                },
                Body = new Serv.ReportRequestBody()
            };

            servReq.Body.ReportRoutes = listr.ToArray();

            




            Serv.AuthHeader auth = new Serv.AuthHeader();
            auth.Authorization = apiKey;
            auth.Date = DateTime.Now.ToString("r");

            EndpointAddress endoint = new EndpointAddress("http://pcmiler.alk.com/APIs/SOAP/V1.0/Service.svc");




            Serv.ServiceClient service = new Serv.ServiceClient();
            service.Endpoint.Address = endoint;



            IEndpointBehavior eb = service.Endpoint.Behaviors.Find<IEndpointBehavior>();

            service.Endpoint.Behaviors.Add(new InspectorBehavior());




            Serv.ReportResponse rsp = service.GetReports(auth, servReq);


            MessageXMLOut = Utility.ToXML(rsp);
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(MessageXMLOut.ToString());
            MessageXMLOut = Utility.ToXML(doc);
            OutputController.ResponseXMLString = MessageXMLOut;
            Form1.SetResponse(OutputController.ResponseXMLString);
            Form1.setRequest(OutputController.RequestXMLString);

            MessageXMLIn = OutputController.RequestXMLString; 
         
            Console.WriteLine(OutputController.ResponseXMLString);

            



        }
    }



  
    class MessageInspector : IClientMessageInspector
    {

        OutputController output = new OutputController();
        public string MessageXMLIn;
        public string MessageXMLOut;



        public void AfterReceiveReply(ref System.ServiceModel.Channels.Message reply, object correlationState)
        {
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(reply.ToString());


            MessageXMLOut = Utility.ToXML(doc);
            OutputController.ResponseXMLString = MessageXMLOut;

            //output.ResponseXMLString = MessageXMLOut;
            String st = OutputController.RequestXMLString;


        }

        public object BeforeSendRequest(ref System.ServiceModel.Channels.Message request, IClientChannel channel)
        {
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(request.ToString());
            MessageXMLIn = Utility.ToXML(doc); ;
            OutputController.RequestXMLString = MessageXMLIn;
            return OutputController.RequestXMLString;
           // return null;
        }
    }

    class InspectorBehavior : IEndpointBehavior
    {
        public void AddBindingParameters(ServiceEndpoint endpoint, BindingParameterCollection bindingParameters)
        {
            return;
        }

        public void ApplyClientBehavior(ServiceEndpoint endpoint, ClientRuntime clientRuntime)
        {
            clientRuntime.MessageInspectors.Add(new MessageInspector());
        }

        public void ApplyDispatchBehavior(ServiceEndpoint endpoint, EndpointDispatcher endpointDispatcher)
        {
            return;
        }
        public void Validate(ServiceEndpoint endpoint) { return; }
    }



    /// </summary>
    static class Utility
    {
        /// <summary>
        /// Serializes an object to XML
        /// </summary>
        /// <param name="response">the object to serialize</param>
        /// <returns>string in XML format</returns>
        public static string ToXML(object obj)
        {
            string xmlOut = string.Empty;
            XmlSerializer xsSubmit = new XmlSerializer(obj.GetType());
            XmlWriterSettings settings = new XmlWriterSettings();
            settings.NewLineHandling = NewLineHandling.Entitize;
            StringWriter sww = new StringWriter();
            XmlWriter writer = XmlWriter.Create(sww, settings);
            xsSubmit.Serialize(writer, obj);
            xmlOut = sww.ToString();

            return xmlOut;
        }

        /// <summary>
        /// Given a stream reader, convert it to an xml string minus the xml declaration and with control feeds and new lines between each element
        /// </summary>
        /// <param name="rd"></param>
        /// <returns></returns>
        public static string ToXML(StreamReader rd)
        {
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(rd.ReadToEnd());

            // Remove the XML declaration element
            if (doc.FirstChild.NodeType == XmlNodeType.XmlDeclaration)
                doc.RemoveChild(doc.FirstChild);

            StringBuilder sb = new StringBuilder();
            XmlWriterSettings settings = new XmlWriterSettings();
            settings.Indent = true;
            settings.IndentChars = "  ";
            settings.NewLineChars = "\r\n";
            settings.OmitXmlDeclaration = true;
            settings.NewLineHandling = NewLineHandling.Replace;
            using (XmlWriter writer = XmlWriter.Create(sb, settings))
            {
                doc.Save(writer);
            }
            return sb.ToString();
        }

        /// <summary>
        /// Given an xml document, convert it to an xml string minus the xml declaration and with control feeds and new lines between each element
        /// </summary>
        /// <param name="doc"></param>
        /// <returns></returns>
        public static string ToXML(XmlDocument doc)
        {
            // Remove the XML declaration element
            if (doc.FirstChild.NodeType == XmlNodeType.XmlDeclaration)
                doc.RemoveChild(doc.FirstChild);

            StringBuilder sb = new StringBuilder();
            XmlWriterSettings settings = new XmlWriterSettings();
            settings.Indent = true;
            settings.IndentChars = "  ";
            settings.NewLineChars = "\r\n";
            settings.OmitXmlDeclaration = true;
            settings.NewLineHandling = NewLineHandling.Replace;
            using (XmlWriter writer = XmlWriter.Create(sb, settings))
            {
                doc.Save(writer);
            }
            return sb.ToString();
        }
    }


}